#include <stdio.h>

#define N 7001

static unsigned hash[N];

static int
is_in_hash (unsigned v)
{
  unsigned i = v % N;

  while (hash[i])
    {
      if (hash[i] == v)
	return 1;
      i++;
      if (i == N)
	i = 0;
    }

  return 0;
}

static void
hash_insert (unsigned v)
{
  unsigned i = v % N;

  while (hash[i])
    {
      i++;
      if (i == N)
	i = 0;
    }

  hash[i] = v;
}

int main (int argc, char *argv[])
{
  FILE *in = fopen (argv[1], "r");
  FILE *hint = fopen (argv[2], "r");
  unsigned x, n, a, i, j, k, s;
  unsigned sol[4];
  int has_sol;

  fscanf (hint, "%d", &has_sol);
  if (!has_sol)
    {
      char buf[100];
      if (!fgets (buf, 100, stdin))
	{
	  fprintf (stderr, "Zadny vystup.\n");
	  return 1;
	}

      /* Umyslne velmi benevolentni test, nechci penalizovat preklepy apod.  */
      if (buf[0] != '"' && buf[0] != 'k' && buf[0] != 'K')
	{
	  fprintf (stderr, "Nevypsan retezec 'Konec sveta se odklada'.\n");
	  return 1;
	}

      fprintf (stderr, "OK\n");
      return 0;
    }

  fscanf (in, "%u%u", &x, &n);
  for (i = 0; i < n; i++)
    {
      fscanf (in, "%u", &a);
      hash_insert (a);
    }

  k = 0;
  while (1)
    {
      if (scanf ("%u", &a) != 1)
	break;

      if (k >= 4)
	{
	  fprintf (stderr, "Prilis mnoho cisel na vystupu.\n");
	  return 1;
	}

      sol[k++] = a;
    }

  if (k == 0)
    {
      fprintf (stderr, "Zadne cislo na vystupu.\n");
      return 1;
    }

  s = 0;
  for (i = 0; i < k; i++)
    {
      if (!is_in_hash (sol[i]))
	{
	  fprintf (stderr, "Cislo %u se nenachazi ve vstupnim souboru.\n", sol[i]);
	  return 1;
	}

      for (j = 0; j < i; j++)
	if (sol[i] == sol[j])
	  {
	    fprintf (stderr, "Cislo %u je pouzito vicekrat.\n", sol[i]);
	    return 1;
	  }
      s += sol[i];
    }

  if (s != x)
    {
      fprintf (stderr, "Spatny soucet.\n");
      return 1;
    }

  fprintf (stderr, "OK\n");
  return 0;
}
